#include <cstdio>
#include <algorithm>
using namespace std;

typedef unsigned int UI;

#define maxN 60
#define maxA 1200
const int maxS=maxN*maxA;

void knapsack(int *a, int maxi, int k, UI b[maxN+1][maxS+1],int *sb)
{
	b[0][0]=1;
	int s=0;
	sb[0]=s;
	for(int i=1;i<=maxi;i++)
	{
		int ai=a[i];
		int j;
		int ss=s+ai;
		if(i>k)
			ss-=min(a[i-k],ai);
		for(j=ss;j>s;j--) b[i][j]=0;
		for(;j>=0;j--)
			b[i][j]=b[i-1][j],
			b[i][j+ai]|=2*b[i-1][j];
		sb[i]=s=ss;
	}
}

int dist(int *s1,int n1,int *s2,int n2,int med)
{
	int ans=1e9;
	int j=n2;
	s2[n2]=1e9;
	for(int i=0;i<n1;i++)
	{
		int val=med-s1[i];
		for(;j>=0 && s2[j]>val;j--);
		if(j>=0) ans=min(ans,val-s2[j]);
		j++;
		ans=min(ans,s2[j]-val);
	}
	return ans;
}

UI pref[maxN+1][maxS+1];
int spref[maxN+1];
UI suf[maxN+1][maxS+1];
int ssuf[maxN+1];
int s1[maxS+1],s2[maxS+1];

int min_dif(int n,int k,int h, int *a)
{
	knapsack(a,n-k+h-1,h-1,pref,spref);
	reverse(a+1,a+1+n);
	knapsack(a,n-h,k-h,suf,ssuf);
	reverse(a+1,a+1+n);
	int ans=1e9;
	int i,j;
	for(i=1;i<=n;i++)
		if(h<=i && n-i>=k-h)
		{
			int n1=0,n2=0;
			for(j=0;j<=spref[i-1];j++)
				if(pref[i-1][j] & 1<<(h-1)) s1[n1++]=j;
			for(j=0;j<=ssuf[n-i];j++)
				if(suf[n-i][j] & 1<<(k-h)) s2[n2++]=j;
			int cur=dist(s1,n1,s2,n2,(k-1)*a[i]);
			if(ans>cur) ans=cur;
		}
	return ans;
}

int main()
{
	int TST;
	scanf("%d",&TST);
	for(int tst=0;tst<TST;tst++)
	{
		int n,k,h;
		scanf("%d%d",&n,&k);
		h=(k+1)/2;
		int a[maxN+1];
		for(int i=1;i<=n;i++)
			scanf("%d",a+i);
		sort(a+1,a+1+n);
		int ans=min_dif(n,k,h,a);
		printf("%.3lf\n",1.*ans/k);
	}
	return 0;
}
